# Generated by go2rpm
%bcond_without check
%bcond_without binary
%bcond_with bootstrap

%if %{with bootstrap}
%global __requires_exclude %{?__requires_exclude:%{__requires_exclude}|}^golang\\(.*\\)$
%endif
%global __requires_exclude %{?__requires_exclude:%{__requires_exclude}|}^golang\\(github.com/coreos/etcd.*\\)$

# https://github.com/docker/swarmkit
%global goipath         github.com/docker/swarmkit
Version:                1.12.0
%global commit          17d8d4e4d8bdec33d386e6362d3537fa9493ba00

%gometa

%global gosupfiles      ${vendor[@]}

%global common_description %{expand:
SwarmKit is a toolkit for orchestrating distributed systems at any scale. It
includes primitives for node discovery, raft-based consensus, task scheduling
and more.

Its main benefits are:
 - Distributed: SwarmKit uses the Raft Consensus Algorithm in order to
   coordinate and does not rely on a single point of failure to perform
   decisions.
 - Secure: Node communication and membership within a Swarm are secure out of
   the box. SwarmKit uses mutual TLS for node authentication, role authorization
   and transport encryption, automating both certificate issuance and rotation.
 - Simple: SwarmKit is operationally simple and minimizes infrastructure
   dependencies. It does not need an external database to operate.}

%global golicenses      LICENSE
%global godocs          BUILDING.md CONTRIBUTING.md README.md

Name:           %{goname}
Release:        %autorelease
Summary:        Toolkit for orchestrating distributed systems at any scale

# Upstream license specification: Apache-2.0
License:        ASL 2.0
URL:            %{gourl}
Source0:        %{gosource}
# Convert BasicKeyRequest to KeyRequest to use cloudflare/cfssl 1.4.1
Patch0:         0001-Convert-BasicKeyRequest-to-KeyRequest-to-use-cloudfl.patch
# https://github.com/docker/swarmkit/commit/55154b878f397d960927a787820f6b80cf7eb058
Patch1:         Compat-with-latest-docker.patch
# https://github.com/docker/swarmkit/commit/9d48b542914e65f9af5fc05588cf8d23d618e4c7
Patch2:         Compat-with-latest-prometheus.patch

%if %{without bootstrap}
BuildRequires:  golang(code.cloudfoundry.org/clock)
BuildRequires:  golang(code.cloudfoundry.org/clock/fakeclock)
BuildRequires:  golang(github.com/cloudflare/cfssl/api)
BuildRequires:  golang(github.com/cloudflare/cfssl/config)
BuildRequires:  golang(github.com/cloudflare/cfssl/csr)
BuildRequires:  golang(github.com/cloudflare/cfssl/errors)
BuildRequires:  golang(github.com/cloudflare/cfssl/helpers)
BuildRequires:  golang(github.com/cloudflare/cfssl/helpers/derhelpers)
BuildRequires:  golang(github.com/cloudflare/cfssl/initca)
BuildRequires:  golang(github.com/cloudflare/cfssl/log)
BuildRequires:  golang(github.com/cloudflare/cfssl/signer)
BuildRequires:  golang(github.com/cloudflare/cfssl/signer/local)
BuildRequires:  golang(github.com/coreos/pkg/capnslog)
BuildRequires:  golang(github.com/docker/distribution/reference)
BuildRequires:  golang(github.com/docker/docker/api/types)
BuildRequires:  golang(github.com/docker/docker/api/types/container)
BuildRequires:  golang(github.com/docker/docker/api/types/events)
BuildRequires:  golang(github.com/docker/docker/api/types/filters)
BuildRequires:  golang(github.com/docker/docker/api/types/mount)
BuildRequires:  golang(github.com/docker/docker/api/types/network)
BuildRequires:  golang(github.com/docker/docker/api/types/volume)
BuildRequires:  golang(github.com/docker/docker/client)
BuildRequires:  golang(github.com/docker/docker/pkg/plugingetter)
BuildRequires:  golang(github.com/docker/docker/pkg/signal)
BuildRequires:  golang(github.com/docker/go-connections/nat)
BuildRequires:  golang(github.com/docker/go-events)
BuildRequires:  golang(github.com/docker/go-metrics)
BuildRequires:  golang(github.com/docker/go-units)
BuildRequires:  golang(github.com/docker/libnetwork/datastore)
BuildRequires:  golang(github.com/docker/libnetwork/driverapi)
BuildRequires:  golang(github.com/docker/libnetwork/drivers/bridge/brmanager)
BuildRequires:  golang(github.com/docker/libnetwork/drivers/host)
BuildRequires:  golang(github.com/docker/libnetwork/drivers/ipvlan/ivmanager)
BuildRequires:  golang(github.com/docker/libnetwork/drivers/macvlan/mvmanager)
BuildRequires:  golang(github.com/docker/libnetwork/drivers/overlay/overlayutils)
BuildRequires:  golang(github.com/docker/libnetwork/drivers/overlay/ovmanager)
BuildRequires:  golang(github.com/docker/libnetwork/drivers/remote)
BuildRequires:  golang(github.com/docker/libnetwork/drvregistry)
BuildRequires:  golang(github.com/docker/libnetwork/idm)
BuildRequires:  golang(github.com/docker/libnetwork/ipamapi)
BuildRequires:  golang(github.com/docker/libnetwork/ipams/builtin)
BuildRequires:  golang(github.com/docker/libnetwork/ipams/null)
BuildRequires:  golang(github.com/docker/libnetwork/ipams/remote)
BuildRequires:  golang(github.com/docker/libnetwork/ipamutils)
BuildRequires:  golang(github.com/docker/libnetwork/netlabel)
BuildRequires:  golang(github.com/dustin/go-humanize)
BuildRequires:  golang(github.com/fernet/fernet-go)
BuildRequires:  golang(github.com/gogo/protobuf/gogoproto)
BuildRequires:  golang(github.com/gogo/protobuf/plugin/testgen)
BuildRequires:  golang(github.com/gogo/protobuf/proto)
BuildRequires:  golang(github.com/gogo/protobuf/protoc-gen-gogo/descriptor)
BuildRequires:  golang(github.com/gogo/protobuf/protoc-gen-gogo/generator)
BuildRequires:  golang(github.com/gogo/protobuf/sortkeys)
BuildRequires:  golang(github.com/gogo/protobuf/types)
BuildRequires:  golang(github.com/gogo/protobuf/vanity)
BuildRequires:  golang(github.com/gogo/protobuf/vanity/command)
BuildRequires:  golang(github.com/grpc-ecosystem/go-grpc-prometheus)
BuildRequires:  golang(github.com/hashicorp/go-memdb)
BuildRequires:  golang(github.com/opencontainers/go-digest)
BuildRequires:  golang(github.com/pkg/errors)
BuildRequires:  golang(github.com/prometheus/client_golang/prometheus)
BuildRequires:  golang(github.com/rcrowley/go-metrics)
BuildRequires:  golang(github.com/sirupsen/logrus)
BuildRequires:  golang(github.com/spf13/cobra)
BuildRequires:  golang(github.com/spf13/pflag)
BuildRequires:  golang(github.com/stretchr/testify/assert)
BuildRequires:  golang(github.com/stretchr/testify/require)
BuildRequires:  golang(go.etcd.io/bbolt)
BuildRequires:  golang(golang.org/x/crypto/nacl/secretbox)
BuildRequires:  golang(golang.org/x/crypto/pbkdf2)
BuildRequires:  golang(golang.org/x/net/context/ctxhttp)
BuildRequires:  golang(golang.org/x/time/rate)
BuildRequires:  golang(google.golang.org/grpc)
BuildRequires:  golang(google.golang.org/grpc/codes)
BuildRequires:  golang(google.golang.org/grpc/credentials)
BuildRequires:  golang(google.golang.org/grpc/grpclog)
BuildRequires:  golang(google.golang.org/grpc/metadata)
BuildRequires:  golang(google.golang.org/grpc/peer)
BuildRequires:  golang(google.golang.org/grpc/status)

%if %{with check}
# Tests
BuildRequires:  golang(github.com/docker/docker/api/types/strslice)
BuildRequires:  golang(github.com/docker/docker/pkg/plugins)
BuildRequires:  golang(github.com/docker/libnetwork/discoverapi)
BuildRequires:  golang(github.com/docker/libnetwork/types)
BuildRequires:  golang(github.com/gogo/protobuf/jsonpb)
BuildRequires:  golang(github.com/onsi/ginkgo)
BuildRequires:  golang(github.com/onsi/gomega)
BuildRequires:  golang(github.com/onsi/gomega/types)
%endif
%endif

%description
%{common_description}

%gopkg

%prep
%goprep -k
# Vendor etcd due to extreme divergence with latest
mkdir -p vendor2/github.com/coreos/
cp -a vendor/github.com/coreos/etcd vendor2/github.com/coreos/
rm -rf vendor/
mv vendor2 vendor
%patch0 -p1
%patch1 -p1
%patch2 -p1

%if %{without bootstrap}
%if %{with binary}
%build
for cmd in cmd/* ; do
  %gobuild -o %{gobuilddir}/bin/$(basename $cmd) %{goipath}/$cmd
done
%endif
%endif

%install
mapfile -t vendor <<< $(find vendor -type f)
%gopkginstall
%if %{without bootstrap}
%if %{with binary}
install -m 0755 -vd                     %{buildroot}%{_bindir}
install -m 0755 -vp %{gobuilddir}/bin/* %{buildroot}%{_bindir}/
%endif
%endif

%if %{without bootstrap}
%if %{with check}
%check
%gocheck -d agent/exec/dockerapi -d agent -d template -d node -d integration -t ca -d manager/dispatcher
%endif
%endif

%if %{without bootstrap}
%if %{with binary}
%files
%license LICENSE
%doc BUILDING.md CONTRIBUTING.md README.md
%{_bindir}/*
%endif
%endif

%gopkgfiles

%changelog
%autochangelog
